package SketchAggSensor;

/**
 * <p>Title: Aggregation Query in Sensor Network with Sketches</p>
 * <p>Description: This code is for the simulation of sensor network with sketches algorithms. It applies with aggregation queries.</p>
 * <p>Copyright: Computer Science Department, Boston University,Copyright (c) 2003</p>
 * <p>Company: Boston University</p>
 * @author Feifei Li
 * @version 1.0
 */

import java.util.*;

/** Predicate represents a simple selection predicate

*/
public class Predicate {
    static final int GE_OP = 0;
    static final int GT_OP = 1;
    static final int LE_OP = 2;
    static final int LT_OP = 3;
    static final int EQ_OP = 4;
    static final int NE_OP = 5;

    public Predicate(int op, int value) throws NoSuchElementException{
        if (op < GE_OP || op> NE_OP)
            throw new NoSuchElementException("Invalid operator.");
        this.op = op;
        this.value = value;
    }

    public boolean apply(int test_value) {
        switch (op) {
        case GE_OP:
            return test_value >= value;
        case GT_OP:
            return test_value > value;
        case  LE_OP:
            return test_value <= value;
        case LT_OP:
            return test_value < value;
        case EQ_OP:
            return test_value == value;
        case NE_OP:
            return test_value != value;
        }
        return false;
    }

    private int value;
    private int op;
}
