package SketchAggSensor.sensor;

/**
 * <p>Title: Aggregation Query in Sensor Network with Sketches</p>
 * <p>Description: This code is for the simulation of sensor network with sketches algorithms. It applies with aggregation queries.</p>
 * <p>Copyright: Computer Science Department, Boston University,Copyright (c) 2003</p>
 * <p>Company: Boston University</p>
 * @author Feifei Li
 * @version 1.0
 */
import SketchAggSensor.*;
import java.util.*;


public interface SensorInterface extends ClockListener{



    public int getId();

    /** @return the current x location of this sensor */
    public int getX();

    /** @return the current y location of this sensor */
    public int getY();

    /** Set the x location of the sensor */
    public void setX(int x) throws InvalidLocationException;

    /** Set the y locaiton of the sensor */
    public void setY(int y) throws InvalidLocationException;

   // public void receiveMessage(Message m);

    public void setTime(int time);

    public int getReading(int field);

    public int msgCount();

    public int getLevel();

    public void setLevel(int l);

    public Vector getParents();

    public void addParents(int pID);

    public Vector getChildren();

    public void addChildren(int childID);

    public int getAgg();

}

